package sharedmodel

import (
	"encoding/json"

	"gorm.io/gorm"
)

type Subscription struct {
	gorm.Model
	SubjectExternalId       string
	SubjectExternalIdSystem string
	SubjectName             string
	SubjectBirthdate        string
	ProtocolMeta            string
	ServiceConfigID         uint
	ServiceConfig           *ServiceConfig
}

func (s Subscription) GetProtocolMeta(meta interface{}) error {
	return json.Unmarshal([]byte(s.ProtocolMeta), meta)
}

func (s *Subscription) SetProtocolMeta(meta interface{}) error {
	b, err := json.Marshal(meta)

	if err != nil {
		return err
	}

	s.ProtocolMeta = string(b)
	return nil
}
